## Azure Storage Blob File System

This module creates a stream wrapper scheme in order to store files
on the Azure Storage cloud service.

## Required

You will need a Microsoft Azure Blob storage account or service running
in order to use this.

* Account name is required.
* Account key is required.

See: https://azure.microsoft.com/services/blob_storage

### Composer Dependencies

```bash
composer require microsoft/azure-storage-blob
```

## Setup/Usage

1. Install and enabled module like any other contrib module.
2. Setup and configure service here: **/admin/config/media/az_blob_fs**
3. Set your default file system to Azure here:
**/admin/config/media/file-system**
4. If using Media, adjust storage settings on the field. Set the
"Upload destination" to "Azure Storage Blob File System".
5. Test uploading media item and confirm it gets pushed to Azure.
6. All Done. Enjoy!

## Responsive Images

Please use https://www.drupal.org/project/image_style_warmer if your
planning to use responsive images. This module helps with warming up
the image styles for the various breakpoints.

Image Style Warmer module will help get the image styles up quicker to
Azure, which in turn will speed up site performance. Image styles can
be warmed up right after media upload or via queue.

## Roadmap

* Get module to a secure state and implement all Drupal coding
standards.
* Tie in Key module to store API keys and other secure details.
* Look into some form of integration with Image Style Warmer
module in the future.

## Credits

* https://www.drupal.org/project/s3fs
* https://www.drupal.org/project/image_style_warmer

## Maintainers

George Anderson (geoanders)
https://www.drupal.org/u/geoanders

Yahya Al Hamad (yahyaalhamad)
https://www.drupal.org/u/yahyaalhamad
